{$R-,S-,I-}
{****************************************************************}
{*                         DAC.PAS                              *}
{*                                                              *}
{*    㭪樨 饣 祭  p  DAC-pp      *}
{*                      (⮫쪮  VGA)                        *}
{*                                                              *}
{*          ᠤ .. p 1.2  p 1991.             *}
{*  .    ᫥ 䨪樨 01.11.1993             *}
{****************************************************************}

unit Dac;

INTERFACE

Type
  PaletteRegs =
    (Black, Blue,  Green,  Cyan,  Red,  Magenta,  Brown,  LGray,
     DGray, LBlue, LGreen, LCyan, LRed, LMagenta, Yelloy, White);

  SetOfDAC = set of PaletteRegs;

Var
  EGA: Boolean;      {- True, ᫨ ⨢ p EGA  }
  VGA: Boolean;      {- True, ᫨ ⨢ p VGA  }


Procedure DecrementScreen;
{-  p  VGA-p }

Procedure IncrementScreen;
{- ⠭ p  VGA-p }

Procedure SetNewColor(Dv: Byte);
{-pp樮쭮  p, ᨭ   ⠢騥 }
{ p祩 p  뢠 祭 祭  DAC-pp }
{ Dv - 樥 pp樮쭮 }

Procedure ReadDAC;
{-⠥  p稩 ᨢ 祭 p᭮, ᨭ   ⠢-}
{  梥⮢, p p祩 p }
{*************************************************************************}
IMPLEMENTATION

const
  SizePalette = 17;
  SizeArr = 64*3;

  ShrTemp = 6;
  Temp    = 64;                { Temp = 2^ShrTemp ! }


Type
  Color_Registers = array [0..SizeArr-1] of Byte;

var
  WorkPalette: array[0..SizePalette-1] of Byte;

{- ppp DAC-pp }
  NewColor,
  OldColor: Color_Registers;


Procedure ReadDAC; assembler;
{-⠥  ᨢ OldColor 祭 p᭮, ᨭ   ⠢-}
{  梥⮢, p p祩 p WorkPalette }
asm
  cmp    [VGA],True
  jne    @@Exit
  mov    ax,1009h         {-p 祭 pp }
  push   ds               { p祩 p }
  pop    es
  lea    dx,WorkPalette
  int    10h

  cld
  lea    si,WorkPalette
  push   ds
  pop    es
  lea    di,OldColor
  mov    cx,SizePalette

@Again:
  mov    dx,03C7h
  lodsb
  out    dx,al
  add    dx,2
  in     al,dx
  stosb
  in     al,dx
  stosb
  in     al,dx
  stosb
  loop   @Again
@@Exit:
end;




Procedure WriteDAC(ColorArr: Color_Registers); assembler;
{-뢠  ᨢ ColorArr 祭 p᭮, ᨭ   ⠢-}
{  梥⮢, p p祩 p WorkPalette }
asm
  mov    dx,03DAh

@1:
  in     al,dx
  test   al,08h
  jne    @1

@2:
  in     al,dx
  test   al,08h
  je     @2

  push   ds
  lea    di,WorkPalette
  lds    si,ColorArr

  cld
  mov    cx,SizePalette
@Again:
  mov    dx,03C8h
  mov    al,es:[di]
  out    dx,al
  inc    di
  inc    dx
  lodsb
  out    dx,al
  lodsb
  out    dx,al
  lodsb
  out    dx,al
  loop   @Again
  pop    ds
end;



Procedure SetNewColor(Dv: Byte);
{-pp樮쭮  p, ᨭ   ⠢騥  }
{ ᨢ NewColor  뢠 祭 祭  DAC-pp   }
begin
  if not VGA then Exit;
  asm
    cld
    mov    ax,ds
    mov    es,ax
    lea    di,NewColor
    lea    si,OldColor
    mov    cl,ShrTemp
    mov    ch,SizeArr
    mov    bl,[Dv]
@Next:
    lodsb
    imul   bl
    shr    ax,cl
    stosb
    dec    ch
    jnz    @Next
  end;
  WriteDAC(NewColor);
end;



Procedure DecrementScreen;
{-  p  VGA-p }
Var
  i: Byte;
begin
  ReadDAC;
  For i := Temp div 2 downto 0 do SetNewColor(2*i);
end;



Procedure IncrementScreen;
{- ⠭ p  VGA-p }
Var
  i: Byte;
begin
  For i := 0 to Temp div 2 do SetNewColor(2*i);
end;


begin
  asm
        xor     ax,ax

        xor     al,al            {- 砫 祭 }
        mov     [EGA],al         { EGA = False }
        mov     [VGA],al         { VGA = False }

        mov     ah,1Ah           {- p  BIOS` }
        int     10h
        cmp     al,1Ah           {-p室, ᫨ 㭪  p }
        jne     @@1              { (..  ⥬  VGA) }

        inc     byte ptr [VGA]   { VGA = True }
        jmp     @@2              {-p室  p ᥣ }


@@1:    mov     bl,10h           {-p p  EGA }
        mov     ah,12h
        int     10h              {-맢 EGA BIOS }
        cmp     bl,10h           {-室, ᫨ 㭪  p }
        je      @@2              { (..  ⥬  EGA) }

        inc     byte ptr [EGA]   { EGA = True }
@@2:
  end;

  if VGA then begin
                asm
                  mov    ax,1009h
                  push   ds
                  pop    es
                  lea    dx,WorkPalette
                  int    10h
                end; {of asm}
              end;
end.



